Subject: Git for structured data

From: Cedric Sodhi <[email-masked]>
Date: Fri, 5 Dec 2025 17:51:01 +0100

Hello (from off list),

a filesystem of Git's working directory type can be seen as a type of database. Compared to other types of databases (relational or not), it might even be considered a fairly complex database with arbitrary nesting depth and relational semantics through symbolic links.

Git excels at version control of this specific type of database, the filesystem. Yet, Git can't be used as-is to version control any other type of database; even though they might be simpler, semantically.

We can have structured data (databases with schemas). We can have version controlled data (files with Git).

Why can't we have structured, version controlled data?

In recent years I've repeatedly struck cases where exactly that was needed. For amounts of data which are comparable to what you typically version with git; only structured. Without workarounds, either structure (table schemas) or versioning (Git) had to be sacrificed. Which is disappointing, in my opinion, seen how this only hinges on the type of source Git would have to read the data from.

I'd like to ask your opinion, on what you think is the most promising approach to unify structure and version control with Git. Currently, I can think of two, kind of complementary options:

A) Map structured data into a filesystem, possibly through FUSE, then version control that with Git.
Pros: Can mix non-structured data and structured data.
Cons: Expect terrible performance

B) Abstract Git's data backend to allow Git to read directly from databases
Pros: Perhaps reasonable performance
Cons: Additional changes to Git would be needed to allow mixing data.

What would you recommend?

Kind regards,
Cedric